gnu: linux-libre: Update to 4.12.
[jackhill/guix/guix.git] / Makefile.am
1 # GNU Guix --- Functional package management for GNU
2 # Copyright © 2012, 2013, 2014, 2015, 2016, 2017 Ludovic Courtès <ludo@gnu.org>
3 # Copyright © 2013 Andreas Enge <andreas@enge.fr>
4 # Copyright © 2015, 2017 Alex Kost <alezost@gmail.com>
5 # Copyright © 2016 Mathieu Lirzin <mthl@gnu.org>
6 # Copyright © 2016, 2017 Mark H Weaver <mhw@netris.org>
7 # Copyright © 2017 Mathieu Othacehe <m.othacehe@gmail.com>
8 # Copyright © 2017 Leo Famulari <leo@famulari.name>
9 # Copyright © 2017 Ricardo Wurmus <rekado@elephly.net>
10 #
11 # This file is part of GNU Guix.
12 #
13 # GNU Guix is free software; you can redistribute it and/or modify it
14 # under the terms of the GNU General Public License as published by
15 # the Free Software Foundation; either version 3 of the License, or (at
16 # your option) any later version.
17 #
18 # GNU Guix is distributed in the hope that it will be useful, but
19 # WITHOUT ANY WARRANTY; without even the implied warranty of
20 # MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE. See the
21 # GNU General Public License for more details.
22 #
23 # You should have received a copy of the GNU General Public License
24 # along with GNU Guix. If not, see <http://www.gnu.org/licenses/>.
25
26 bin_SCRIPTS = \
27 scripts/guix
28
29 nodist_noinst_SCRIPTS = \
30 pre-inst-env \
31 test-env
32
33 # Modules that are not compiled but are installed nonetheless, such as
34 # build-side modules with unusual dependencies.
35 MODULES_NOT_COMPILED =
36
37 include gnu/local.mk
38
39 MODULES = \
40 guix/base16.scm \
41 guix/base32.scm \
42 guix/base64.scm \
43 guix/cpio.scm \
44 guix/records.scm \
45 guix/gcrypt.scm \
46 guix/hash.scm \
47 guix/pk-crypto.scm \
48 guix/pki.scm \
49 guix/combinators.scm \
50 guix/memoization.scm \
51 guix/utils.scm \
52 guix/sets.scm \
53 guix/modules.scm \
54 guix/download.scm \
55 guix/discovery.scm \
56 guix/git-download.scm \
57 guix/hg-download.scm \
58 guix/monads.scm \
59 guix/monad-repl.scm \
60 guix/gexp.scm \
61 guix/profiles.scm \
62 guix/serialization.scm \
63 guix/nar.scm \
64 guix/derivations.scm \
65 guix/grafts.scm \
66 guix/gnu-maintenance.scm \
67 guix/upstream.scm \
68 guix/licenses.scm \
69 guix/graph.scm \
70 guix/cache.scm \
71 guix/cve.scm \
72 guix/workers.scm \
73 guix/zlib.scm \
74 guix/build-system.scm \
75 guix/build-system/ant.scm \
76 guix/build-system/cargo.scm \
77 guix/build-system/cmake.scm \
78 guix/build-system/dub.scm \
79 guix/build-system/emacs.scm \
80 guix/build-system/font.scm \
81 guix/build-system/asdf.scm \
82 guix/build-system/glib-or-gtk.scm \
83 guix/build-system/gnu.scm \
84 guix/build-system/haskell.scm \
85 guix/build-system/perl.scm \
86 guix/build-system/python.scm \
87 guix/build-system/ocaml.scm \
88 guix/build-system/waf.scm \
89 guix/build-system/r.scm \
90 guix/build-system/ruby.scm \
91 guix/build-system/texlive.scm \
92 guix/build-system/trivial.scm \
93 guix/ftp-client.scm \
94 guix/http-client.scm \
95 guix/gnupg.scm \
96 guix/elf.scm \
97 guix/store.scm \
98 guix/cvs-download.scm \
99 guix/svn-download.scm \
100 guix/ui.scm \
101 guix/build/ant-build-system.scm \
102 guix/build/download.scm \
103 guix/build/cargo-build-system.scm \
104 guix/build/cmake-build-system.scm \
105 guix/build/dub-build-system.scm \
106 guix/build/emacs-build-system.scm \
107 guix/build/font-build-system.scm \
108 guix/build/asdf-build-system.scm \
109 guix/build/git.scm \
110 guix/build/hg.scm \
111 guix/build/glib-or-gtk-build-system.scm \
112 guix/build/gnu-build-system.scm \
113 guix/build/gnu-dist.scm \
114 guix/build/perl-build-system.scm \
115 guix/build/python-build-system.scm \
116 guix/build/ocaml-build-system.scm \
117 guix/build/r-build-system.scm \
118 guix/build/ruby-build-system.scm \
119 guix/build/texlive-build-system.scm \
120 guix/build/waf-build-system.scm \
121 guix/build/haskell-build-system.scm \
122 guix/build/store-copy.scm \
123 guix/build/utils.scm \
124 guix/build/union.scm \
125 guix/build/profiles.scm \
126 guix/build/pull.scm \
127 guix/build/rpath.scm \
128 guix/build/cvs.scm \
129 guix/build/svn.scm \
130 guix/build/syscalls.scm \
131 guix/build/gremlin.scm \
132 guix/build/emacs-utils.scm \
133 guix/build/java-utils.scm \
134 guix/build/lisp-utils.scm \
135 guix/build/graft.scm \
136 guix/build/bournish.scm \
137 guix/build/qt-utils.scm \
138 guix/build/make-bootstrap.scm \
139 guix/search-paths.scm \
140 guix/packages.scm \
141 guix/import/utils.scm \
142 guix/import/gnu.scm \
143 guix/import/snix.scm \
144 guix/import/cabal.scm \
145 guix/import/cran.scm \
146 guix/import/hackage.scm \
147 guix/import/elpa.scm \
148 guix/import/texlive.scm \
149 guix/scripts.scm \
150 guix/scripts/download.scm \
151 guix/scripts/perform-download.scm \
152 guix/scripts/build.scm \
153 guix/scripts/archive.scm \
154 guix/scripts/import.scm \
155 guix/scripts/package.scm \
156 guix/scripts/gc.scm \
157 guix/scripts/hash.scm \
158 guix/scripts/pack.scm \
159 guix/scripts/pull.scm \
160 guix/scripts/substitute.scm \
161 guix/scripts/authenticate.scm \
162 guix/scripts/refresh.scm \
163 guix/scripts/system.scm \
164 guix/scripts/lint.scm \
165 guix/scripts/challenge.scm \
166 guix/scripts/import/cran.scm \
167 guix/scripts/import/gnu.scm \
168 guix/scripts/import/nix.scm \
169 guix/scripts/import/hackage.scm \
170 guix/scripts/import/elpa.scm \
171 guix/scripts/import/texlive.scm \
172 guix/scripts/environment.scm \
173 guix/scripts/publish.scm \
174 guix/scripts/edit.scm \
175 guix/scripts/size.scm \
176 guix/scripts/graph.scm \
177 guix/scripts/container.scm \
178 guix/scripts/container/exec.scm \
179 guix.scm \
180 $(GNU_SYSTEM_MODULES)
181
182 if HAVE_GUILE_JSON
183
184 MODULES += \
185 guix/docker.scm \
186 guix/import/cpan.scm \
187 guix/import/crate.scm \
188 guix/import/gem.scm \
189 guix/import/github.scm \
190 guix/import/json.scm \
191 guix/import/pypi.scm \
192 guix/import/stackage.scm \
193 guix/scripts/import/crate.scm \
194 guix/scripts/import/gem.scm \
195 guix/scripts/import/pypi.scm \
196 guix/scripts/import/stackage.scm
197
198 endif
199
200 if HAVE_GUILE_SSH
201
202 MODULES += \
203 guix/ssh.scm \
204 guix/scripts/copy.scm \
205 guix/store/ssh.scm
206
207 endif HAVE_GUILE_SSH
208
209 if HAVE_GUILE_GIT
210
211 MODULES += \
212 guix/git.scm
213
214 endif HAVE_GUILE_GIT
215
216 if BUILD_DAEMON_OFFLOAD
217
218 MODULES += \
219 guix/scripts/offload.scm
220
221 endif BUILD_DAEMON_OFFLOAD
222
223 # Internal modules with test suite support.
224 dist_noinst_DATA = guix/tests.scm guix/tests/http.scm
225
226 # Auxiliary files for packages.
227 AUX_FILES = \
228 gnu/packages/aux-files/emacs/guix-emacs.el \
229 gnu/packages/aux-files/linux-libre/4.12-i686.conf \
230 gnu/packages/aux-files/linux-libre/4.12-x86_64.conf \
231 gnu/packages/aux-files/linux-libre/4.9-i686.conf \
232 gnu/packages/aux-files/linux-libre/4.9-x86_64.conf \
233 gnu/packages/aux-files/linux-libre/4.4-i686.conf \
234 gnu/packages/aux-files/linux-libre/4.4-x86_64.conf \
235 gnu/packages/aux-files/linux-libre/4.1-i686.conf \
236 gnu/packages/aux-files/linux-libre/4.1-x86_64.conf
237
238 # Templates, examples.
239 EXAMPLES = \
240 gnu/system/examples/bare-bones.tmpl \
241 gnu/system/examples/desktop.tmpl \
242 gnu/system/examples/lightweight-desktop.tmpl \
243 gnu/system/examples/vm-image.tmpl
244
245 GOBJECTS = $(MODULES:%.scm=%.go) guix/config.go $(dist_noinst_DATA:%.scm=%.go)
246
247 nobase_dist_guilemodule_DATA = \
248 $(MODULES) $(MODULES_NOT_COMPILED) $(AUX_FILES) $(EXAMPLES) \
249 $(MISC_DISTRO_FILES)
250 nobase_nodist_guilemodule_DATA = guix/config.scm
251 nobase_nodist_guileobject_DATA = $(GOBJECTS)
252
253 # Handy way to remove the .go files without removing all the rest.
254 clean-go:
255 -$(RM) -f $(GOBJECTS)
256 @find . -name '*.go' -print | \
257 if test -t 1; then \
258 xargs -r echo -e "\033[31mwarning:\033[0m stray .go files:"; \
259 else \
260 xargs -r echo "warning: stray .go files:"; \
261 fi
262
263
264 # Test extensions; has to be unconditional.
265 TEST_EXTENSIONS = .scm .sh
266
267 if CAN_RUN_TESTS
268
269 SCM_TESTS = \
270 tests/base16.scm \
271 tests/base32.scm \
272 tests/base64.scm \
273 tests/cpio.scm \
274 tests/hash.scm \
275 tests/pk-crypto.scm \
276 tests/pki.scm \
277 tests/sets.scm \
278 tests/modules.scm \
279 tests/gnu-maintenance.scm \
280 tests/substitute.scm \
281 tests/builders.scm \
282 tests/derivations.scm \
283 tests/grafts.scm \
284 tests/ui.scm \
285 tests/records.scm \
286 tests/upstream.scm \
287 tests/combinators.scm \
288 tests/discovery.scm \
289 tests/utils.scm \
290 tests/build-utils.scm \
291 tests/packages.scm \
292 tests/snix.scm \
293 tests/hackage.scm \
294 tests/cran.scm \
295 tests/elpa.scm \
296 tests/texlive.scm \
297 tests/store.scm \
298 tests/monads.scm \
299 tests/gexp.scm \
300 tests/nar.scm \
301 tests/union.scm \
302 tests/profiles.scm \
303 tests/search-paths.scm \
304 tests/syscalls.scm \
305 tests/gremlin.scm \
306 tests/bournish.scm \
307 tests/lint.scm \
308 tests/publish.scm \
309 tests/scripts.scm \
310 tests/size.scm \
311 tests/graph.scm \
312 tests/challenge.scm \
313 tests/cache.scm \
314 tests/cve.scm \
315 tests/workers.scm \
316 tests/zlib.scm \
317 tests/file-systems.scm \
318 tests/system.scm \
319 tests/services.scm \
320 tests/scripts-build.scm \
321 tests/containers.scm \
322 tests/pack.scm \
323 tests/import-utils.scm
324
325 if HAVE_GUILE_JSON
326
327 SCM_TESTS += \
328 tests/pypi.scm \
329 tests/cpan.scm \
330 tests/gem.scm \
331 tests/crate.scm
332
333 endif
334
335 SH_TESTS = \
336 tests/guix-build.sh \
337 tests/guix-download.sh \
338 tests/guix-gc.sh \
339 tests/guix-hash.sh \
340 tests/guix-package.sh \
341 tests/guix-package-net.sh \
342 tests/guix-system.sh \
343 tests/guix-archive.sh \
344 tests/guix-authenticate.sh \
345 tests/guix-environment.sh \
346 tests/guix-environment-container.sh \
347 tests/guix-graph.sh \
348 tests/guix-lint.sh
349
350 if BUILD_DAEMON
351
352 SH_TESTS += tests/guix-register.sh
353
354 endif BUILD_DAEMON
355
356
357 TESTS = $(SCM_TESTS) $(SH_TESTS)
358
359 AM_TESTS_ENVIRONMENT = abs_top_srcdir="$(abs_top_srcdir)" GUILE_AUTO_COMPILE=0
360
361 SCM_LOG_DRIVER = \
362 $(top_builddir)/test-env --quiet-stderr \
363 $(GUILE) --no-auto-compile -e main \
364 $(top_srcdir)/build-aux/test-driver.scm
365
366 AM_SCM_LOG_DRIVER_FLAGS = --brief=yes
367
368 SH_LOG_COMPILER = $(top_builddir)/test-env $(SHELL)
369 AM_SH_LOG_FLAGS = -x -e
370
371 # Make sure `tests/guix-gc.sh' runs last, after all the others. Otherwise it
372 # could end up removing files from the store while they are being used by
373 # other instances of the daemon.
374 tests/guix-gc.log: \
375 $(patsubst %.sh,%.log,$(filter-out tests/guix-gc.sh,$(SH_TESTS))) \
376 $(SCM_TESTS:%.scm=%.log)
377
378 else !CAN_RUN_TESTS
379
380 TESTS =
381 SH_TESTS =
382 SCM_TESTS =
383
384 # Automake always generates a 'check' target, so better not override it.
385 check-local:
386 @echo
387 @echo "Cannot run tests because file name limits would be exceeded." >&2
388 @echo "Look for 'length' in the 'config.log' file for details." >&2
389 @echo
390 @exit 1
391
392 endif !CAN_RUN_TESTS
393
394 check-system: $(GOBJECTS) $(BOOTSTRAP_GUILE_TARBALLS)
395 $(AM_V_at)$(top_builddir)/pre-inst-env \
396 $(GUILE) --no-auto-compile \
397 -e '(@@ (run-system-tests) run-system-tests)' \
398 $(top_srcdir)/build-aux/run-system-tests.scm
399
400 # Public key used to sign substitutes from hydra.gnu.org & co.
401 dist_pkgdata_DATA = \
402 hydra.gnu.org.pub \
403 bayfront.guixsd.org.pub
404
405 # Bash completion file.
406 dist_bashcompletion_DATA = etc/completion/bash/guix
407
408 # Zsh completion file.
409 dist_zshcompletion_DATA = etc/completion/zsh/_guix
410
411 EXTRA_DIST = \
412 HACKING \
413 ROADMAP \
414 TODO \
415 CODE-OF-CONDUCT \
416 .dir-locals.el \
417 build-aux/build-self.scm \
418 build-aux/compile-all.scm \
419 build-aux/hydra/evaluate.scm \
420 build-aux/hydra/gnu-system.scm \
421 build-aux/hydra/guix.scm \
422 build-aux/check-available-binaries.scm \
423 build-aux/check-final-inputs-self-contained.scm \
424 build-aux/download.scm \
425 build-aux/generate-authors.scm \
426 build-aux/test-driver.scm \
427 build-aux/update-guix-package.scm \
428 build-aux/update-NEWS.scm \
429 build-aux/run-system-tests.scm \
430 d3.v3.js \
431 graph.js \
432 srfi/srfi-64.scm \
433 srfi/srfi-64.upstream.scm \
434 tests/test.drv \
435 tests/signing-key.pub \
436 tests/signing-key.sec \
437 tests/cve-sample.xml \
438 build-aux/config.rpath \
439 bootstrap \
440 release.nix \
441 $(TESTS)
442
443 if !BUILD_DAEMON_OFFLOAD
444
445 EXTRA_DIST += \
446 guix/scripts/offload.scm
447
448 endif !BUILD_DAEMON_OFFLOAD
449
450
451 CLEANFILES = \
452 $(GOBJECTS) \
453 $(SCM_TESTS:tests/%.scm=%.log)
454
455 # Unset 'GUILE_LOAD_COMPILED_PATH' altogether while compiling. Otherwise, if
456 # $GUILE_LOAD_COMPILED_PATH contains $(moduledir), we may find .go files in
457 # there that are newer than the local .scm files (for instance because the
458 # user ran 'make install' recently). When that happens, we end up loading
459 # those previously-installed .go files, which may be stale, thereby breaking
460 # the whole thing. Likewise, set 'XDG_CACHE_HOME' to avoid loading possibly
461 # stale files from ~/.cache/guile/ccache.
462 %.go: make-go ; @:
463 make-go: $(MODULES) guix/config.scm $(dist_noinst_DATA)
464 $(AM_V_at)echo "Compiling Scheme modules..." ; \
465 unset GUILE_LOAD_COMPILED_PATH ; \
466 XDG_CACHE_HOME=/nowhere \
467 host=$(host) srcdir="$(top_srcdir)" \
468 $(top_builddir)/pre-inst-env \
469 $(GUILE) -L "$(top_builddir)" -L "$(top_srcdir)" \
470 --no-auto-compile \
471 -s "$(top_srcdir)"/build-aux/compile-all.scm $^
472
473 SUFFIXES = .go
474
475 # Make sure source files are installed first, so that the mtime of
476 # installed compiled files is greater than that of installed source
477 # files. See
478 # <http://lists.gnu.org/archive/html/guile-devel/2010-07/msg00125.html>
479 # for details.
480 guix_install_go_files = install-nobase_nodist_guileobjectDATA
481 $(guix_install_go_files): install-nobase_dist_guilemoduleDATA
482
483 # The above trick doesn't work for 'config.go' because both 'config.scm' and
484 # 'config.go' are listed in $(nobase_nodist_guileobject_DATA). Thus, give it
485 # special treatment.
486 install-data-hook: set-bootstrap-executable-permissions
487 touch "$(DESTDIR)$(guileobjectdir)/guix/config.go"
488
489
490 SUBDIRS = po/guix po/packages
491 BUILT_SOURCES =
492
493 include doc/local.mk
494
495 if BUILD_DAEMON
496
497 include nix/local.mk
498
499 endif BUILD_DAEMON
500
501 ACLOCAL_AMFLAGS = -I m4
502
503 # Pass an explicit '--localstatedir' so that configure does not error out if
504 # it finds an existing installation with a different localstatedir. Inherit
505 # 'ac_cv_guix_test_root' so that "make check" in $(distdir) does not have to
506 # repopulate the whole store, and to make sure $(GUIX_TEST_ROOT) is short
507 # enough for shebangs.
508 AM_DISTCHECK_CONFIGURE_FLAGS = \
509 --localstatedir="$$dc_install_base/var" \
510 --with-libgcrypt-prefix="$(LIBGCRYPT_PREFIX)" \
511 --with-libgcrypt-libdir="$(LIBGCRYPT_LIBDIR)" \
512 --with-nix-prefix="$(NIX_PREFIX)" \
513 --enable-daemon \
514 ac_cv_guix_test_root="$(GUIX_TEST_ROOT)"
515
516 # The self-contained tarball. Add 'glibc-utf8-locales' along with glibc just
517 # so 'etc/profile' defines 'GUIX_LOCPATH' pointing to a valid set of locales.
518 guix-binary.%.tar.xz:
519 $(AM_V_GEN)GUIX_PACKAGE_PATH= \
520 tarball=`$(top_builddir)/pre-inst-env guix pack -K -C xz \
521 -s "$*" --localstatedir guix glibc-utf8-locales \
522 -e '(@@ (gnu packages commencement) glibc-final)'` ; \
523 cp "$$tarball" "$@.tmp" ; mv "$@.tmp" "$@"
524
525
526 dist-hook: $(distdir)/ChangeLog gen-AUTHORS gen-tarball-version
527 dist-hook: assert-no-store-file-names
528
529 distcheck-hook: assert-binaries-available assert-final-inputs-self-contained
530
531 EXTRA_DIST += $(top_srcdir)/.version
532 BUILT_SOURCES += $(top_srcdir)/.version
533 $(top_srcdir)/.version:
534 echo $(VERSION) > "$@-t" && mv "$@-t" "$@"
535
536 gen-tarball-version:
537 echo $(VERSION) > "$(distdir)/.tarball-version"
538
539 gen-ChangeLog $(distdir)/ChangeLog:
540 $(AM_V_GEN)if test -d .git; then \
541 $(top_srcdir)/build-aux/gitlog-to-changelog \
542 > $(distdir)/cl-t; \
543 rm -f $(distdir)/ChangeLog; \
544 mv $(distdir)/cl-t $(distdir)/ChangeLog; \
545 fi
546
547 gen-AUTHORS:
548 $(AM_V_GEN)if test -d .git; then \
549 rm -f "$(distdir)/AUTHORS"; \
550 $(top_builddir)/pre-inst-env "$(GUILE)" \
551 "$(top_srcdir)/build-aux/generate-authors.scm" \
552 "$(top_srcdir)" "$(distdir)/AUTHORS"; \
553 fi
554
555 \f
556 #
557 # Release management.
558 #
559
560 releasedir = release-$(PACKAGE_VERSION)
561
562 PACKAGE_FULL_TARNAME = $(PACKAGE_TARNAME)-$(PACKAGE_VERSION)
563
564 # List of source tarballs produced. This must be kept in sync with the
565 # 'dist-' options of 'AM_INIT_AUTOMAKE' in 'configure.ac'.
566 SOURCE_TARBALLS = \
567 $(foreach ext,tar.gz,$(PACKAGE_FULL_TARNAME).$(ext))
568
569 # Systems supported by Guix.
570 SUPPORTED_SYSTEMS ?= x86_64-linux i686-linux armhf-linux
571
572 # Guix binary tarballs.
573 BINARY_TARBALLS = \
574 $(foreach system,$(SUPPORTED_SYSTEMS),guix-binary.$(system).tar.xz)
575
576 # Systems supported by GuixSD.
577 GUIXSD_SUPPORTED_SYSTEMS ?= x86_64-linux i686-linux
578
579 # Systems for which we build GuixSD VMs.
580 GUIXSD_VM_SYSTEMS ?= x86_64-linux
581
582 # Prefix of the GuixSD installation image file name.
583 GUIXSD_IMAGE_BASE = guixsd-usb-install-$(PACKAGE_VERSION)
584
585 # Prefix of the GuixSD VM image file name.
586 GUIXSD_VM_IMAGE_BASE = guixsd-vm-image-$(PACKAGE_VERSION)
587
588 # Size of the VM image (for x86_64 typically).
589 GUIXSD_VM_IMAGE_SIZE ?= 2GiB
590
591 # The release process works in several phases:
592 #
593 # 0. We assume the developer created a 'vX.Y' tag.
594 # 1. Build the source tarball.
595 # 2. Update the 'guix' package so that it corresponds to the 'vX.Y' tag.
596 # 3. Build the binary tarballs for that 'guix' package.
597 # 4. Update the 'guix' package again.
598 # 5. Build the GuixSD installation images. The images will run 'guix'
599 # corresponding to 'vX.Y' + 1 commit, and they will install 'vX.Y'.
600 #
601 # This 'release' target takes care of everything and copies the resulting
602 # files to $(releasedir).
603 #
604 # XXX: Depend on 'dist' rather than 'distcheck' to work around the Gettext
605 # issue described at <https://savannah.gnu.org/bugs/index.php?51027>.
606 release: dist
607 cd po; git checkout .
608 @if ! git diff-index --quiet HEAD; then \
609 echo "There are uncommitted changes; stopping." >&2 ; \
610 exit 1 ; \
611 fi
612 $(MKDIR_P) "$(releasedir)"
613 rm -f "$(releasedir)"/*
614 mv $(SOURCE_TARBALLS) "$(releasedir)"
615 $(top_builddir)/pre-inst-env "$(GUILE)" \
616 $(top_srcdir)/build-aux/update-guix-package.scm \
617 "`git rev-parse HEAD`" "$(PACKAGE_VERSION)"
618 git add $(top_srcdir)/gnu/packages/package-management.scm
619 git commit -m "gnu: guix: Update to $(PACKAGE_VERSION)."
620 rm -f $(BINARY_TARBALLS)
621 $(MAKE) $(BINARY_TARBALLS)
622 for system in $(SUPPORTED_SYSTEMS) ; do \
623 mv "guix-binary.$$system.tar.xz" \
624 "$(releasedir)/guix-binary-$(PACKAGE_VERSION).$$system.tar.xz" ; \
625 done
626 $(top_builddir)/pre-inst-env "$(GUILE)" \
627 $(top_srcdir)/build-aux/update-guix-package.scm \
628 "`git rev-parse HEAD`"
629 git add $(top_srcdir)/gnu/packages/package-management.scm
630 git commit -m "gnu: guix: Update to `git rev-parse HEAD | cut -c1-7`."
631 for system in $(GUIXSD_SUPPORTED_SYSTEMS) ; do \
632 image=`$(top_builddir)/pre-inst-env \
633 guix system disk-image \
634 --system=$$system \
635 gnu/system/install.scm` ; \
636 if [ ! -f "$$image" ] ; then \
637 echo "failed to produced GuixSD installation image for $$system" >&2 ; \
638 exit 1 ; \
639 fi ; \
640 xz < "$$image" > "$(releasedir)/$(GUIXSD_IMAGE_BASE).$$system.xz.tmp" ; \
641 mv "$(releasedir)/$(GUIXSD_IMAGE_BASE).$$system.xz.tmp" \
642 "$(releasedir)/$(GUIXSD_IMAGE_BASE).$$system.xz" ; \
643 done
644 for system in $(GUIXSD_VM_SYSTEMS) ; do \
645 image=`$(top_builddir)/pre-inst-env \
646 guix system vm-image \
647 --system=$$system \
648 --image-size=$(GUIXSD_VM_IMAGE_SIZE) \
649 gnu/system/examples/vm-image.tmpl` ; \
650 if [ ! -f "$$image" ] ; then \
651 echo "failed to produced GuixSD VM image for $$system" >&2 ; \
652 exit 1 ; \
653 fi ; \
654 xz < "$$image" > "$(releasedir)/$(GUIXSD_VM_IMAGE_BASE).$$system.xz.tmp" ; \
655 mv "$(releasedir)/$(GUIXSD_VM_IMAGE_BASE).$$system.xz.tmp" \
656 "$(releasedir)/$(GUIXSD_VM_IMAGE_BASE).$$system.xz" ; \
657 done
658 @echo
659 @echo "Congratulations! All the release files are now in $(releasedir)."
660 @echo
661
662 update-guix-package:
663 git rev-parse HEAD
664 $(top_builddir)/pre-inst-env "$(GUILE)" \
665 $(top_srcdir)/build-aux/update-guix-package.scm \
666 "`git rev-parse HEAD`"
667
668 # Location of a checkout of <git://git.savannah.gnu.org/guix/maintenance.git>.
669 # Package data from this checkout is used by 'update-NEWS.scm'.
670 GUIX_MAINTENANCE_DIRECTORY ?= $(top_srcdir)/../guix-maintenance
671
672 update-NEWS: $(GOBJECTS)
673 $(top_builddir)/pre-inst-env "$(GUILE)" \
674 $(top_srcdir)/build-aux/update-NEWS.scm \
675 $(top_srcdir)/NEWS "$(GUIX_MAINTENANCE_DIRECTORY)/data"
676
677 # Make sure we're not shipping a file that embeds a local /gnu/store file name.
678 assert-no-store-file-names: $(distdir)/ChangeLog
679 $(AM_V_at)if grep -r --exclude=*.texi --exclude=*.info \
680 --exclude=*.info-[0-9] --exclude=*.dot \
681 --exclude=*.eps --exclude-dir=bootstrap \
682 --exclude=guix-prettify.el \
683 --exclude=ChangeLog \
684 -E "$(storedir)/[a-z0-9]{32}-" $(distdir) ; \
685 then \
686 echo "error: store file names embedded in the distribution" >&2 ; \
687 exit 1 ; \
688 fi
689
690 # Make sure hydra.gnu.org has the important binaries.
691 assert-binaries-available: $(GOBJECTS)
692 $(AM_V_at)$(top_builddir)/pre-inst-env "$(GUILE)" \
693 "$(top_srcdir)/build-aux/check-available-binaries.scm"
694
695 # Make sure the final inputs don't refer to bootstrap tools.
696 assert-final-inputs-self-contained: $(GOBJECTS)
697 $(AM_V_at)$(top_builddir)/pre-inst-env "$(GUILE)" \
698 "$(top_srcdir)/build-aux/check-final-inputs-self-contained.scm"
699
700 # Compute the Hydra jobs and write them in the target file.
701 hydra-jobs.scm: $(GOBJECTS)
702 $(AM_V_at)$(MKDIR_P) "`dirname "$@"`"
703 $(AM_V_GEN)$(top_builddir)/pre-inst-env "$(GUILE)" \
704 "$(top_srcdir)/build-aux/hydra/evaluate.scm" \
705 "$(top_srcdir)/build-aux/hydra/gnu-system.scm" > "$@.tmp"
706 $(AM_V_at)mv "$@.tmp" "$@"
707
708 .PHONY: gen-ChangeLog gen-AUTHORS gen-tarball-version
709 .PHONY: assert-no-store-file-names assert-binaries-available
710 .PHONY: assert-final-inputs-self-contained
711 .PHONY: clean-go make-go
712 .PHONY: update-guix-package update-NEWS release
713
714 ## -------------- ##
715 ## Silent rules. ##
716 ## -------------- ##
717
718 AM_V_DL = $(AM_V_DL_$(V))
719 AM_V_DL_ = $(AM_V_DL_$(AM_DEFAULT_VERBOSITY))
720 AM_V_DL_0 = @echo " DL " $@;
721
722 AM_V_DOT = $(AM_V_DOT_$(V))
723 AM_V_DOT_ = $(AM_V_DOT_$(AM_DEFAULT_VERBOSITY))
724 AM_V_DOT_0 = @echo " DOT " $@;
725
726 AM_V_HELP2MAN = $(AM_V_HELP2MAN_$(V))
727 AM_V_HELP2MAN_ = $(AM_V_HELP2MAN_$(AM_DEFAULT_VERBOSITY))
728 AM_V_HELP2MAN_0 = @echo " HELP2MAN" $@;